package eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class LinkedBeaconTeleporterItem extends LinkedBeaconTeleporter {
    // INFO: Safe to store as its always cloned by bukkit
    ItemStack item;

    public LinkedBeaconTeleporterItem(){
        // Create a new LinkedBeaconTeleporter
        super();

        this.item = Main.lbtManager.getItemStackFromData(this.teleporterId);
    }
    public LinkedBeaconTeleporterItem(String teleporterId, ItemStack item) {
        super(teleporterId);

        this.item = item;
    }
    public LinkedBeaconTeleporterItem(String teleporterId){
        super(teleporterId);

        this.item = Main.lbtManager.getItemStackFromData(teleporterId);
    }

    public ItemStack item(){
        return item;
    }


    public LinkedBeaconTeleporterBlock place(BlockPlaceEvent e){
        Block block = e.getBlock();
        Location loc = block.getLocation();

        // Block from item
        LinkedBeaconTeleporterBlock lbtBlock = new LinkedBeaconTeleporterBlock(this.teleporterId(), block);
        // Add to list
        this.linkedBeaconTeleporters.add(lbtBlock);

        // Add to id if not exists
        if(!Main.lbtManager.placedLBTsById.containsKey(this.teleporterId))
            Main.lbtManager.placedLBTsById.put(this.teleporterId, this.linkedBeaconTeleporters);

        // Add to location
        Main.lbtManager.placedLBTByLoc.put(
                Function.serialiseBlockLocation(loc),
                lbtBlock
        );

        return lbtBlock;
    }


    // Conversion methods
    public static LinkedBeaconTeleporterItem getFromItemStack(ItemStack itemStack){
        return Main.lbtManager.getLbtItemFromItemStack(itemStack);
    }
}
